%
% function Psi = DWT_Matrix(N, lifting_scheme, num_levels)
%
%   This function returns the N x N orthonormal transform matrix
%   associated with the DWT given by lifting_scheme.
%

%
% CPPCA: Compressive-Projection Principal Component Analysis
% Copyright (C) 2007-2014  James E. Fowler
% http://www.ece.mstate.edu/~fowler
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%


function Psi = DWT_Matrix(N, lifting_scheme, num_levels)

x = zeros(N, 1);
x(1) = 1;
Psi = zeros(N, N);
for n = 1:N
  Psi(:, n) = ilwt(x, lifting_scheme, num_levels);
  x = [x(N); x(1:(N-1))];
end
