%
% function Run_TIP_Fig5()
%
%   This function reproduces results from the paper:
%     J. E. Fowler, "Compressive-Projection Principal Component
%       Analysis," submitted to IEEE Transactions on Image Processing,
%       June 2008. Revised February 2009.
%  
%   Specifically, this function produces Fig. 5.
%

%
% CPPCA: Compressive-Projection Principal Component Analysis
% Copyright (C) 2007-2014  James E. Fowler
% http://www.ece.mstate.edu/~fowler
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%


function Run_TIP_Fig5()

M = 10000;
filename = 'cuprite';

fid = fopen([filename '.dat'], 'r', 'ieee-be');
X = fread(fid, [224 M], 'float32');
fclose(fid);

[N M] = size(X);
Sigma = (X * X')/M;
[Psi, S, V] = svd(Sigma);

k = 1:50;

s = diag(S);

semilogy(k, s(k), 'k-x', 'LineWidth', 2);
grid on
xlabel('n');
ylabel('Eigenvalues, \lambda_n({\bf\Sigma})');

